// Copyright 2019 Diffuse Logic, all rights reserved.

#ifndef DL_CORE_HW_H
#define DL_CORE_HW_H

#include "dl_string.h"

// Get info about the current hardware.
//
namespace dl {
namespace hw {

String DL_API       vendorString();
String DL_API       osInfo();
String DL_API       hwInfo();

bool DL_API         canUseAVX();
bool DL_API         canUseAVX512();

bool DL_API         isAMD();
bool DL_API         isIntel();

// OS Features
bool DL_API         osX64();
bool DL_API         osAVX();
bool DL_API         osAVX512();

// Misc.
bool DL_API         hwMMX();
bool DL_API         hwIsX64();
bool DL_API         hwABM();
bool DL_API         hwRDRAND();
bool DL_API         hwBMI1();
bool DL_API         hwBMI2();
bool DL_API         hwADX();
bool DL_API         hwPREFETCHWT1();
bool DL_API         hwMPX();

// SIMD: 128-bit
bool DL_API         hwSSE();
bool DL_API         hwSSE2();
bool DL_API         hwSSE3();
bool DL_API         hwSSSE3();
bool DL_API         hwSSE41();
bool DL_API         hwSSE42();
bool DL_API         hwSSE4a();
bool DL_API         hwAES();
bool DL_API         hwSHA();

// SIMD: 256-bit
bool DL_API         hwAVX();
bool DL_API         hwXOP();
bool DL_API         hwFMA3();
bool DL_API         hwFMA4();
bool DL_API         hwAVX2();

// SIMD: 512-bit
bool DL_API         hwAVX512_F();
bool DL_API         hwAVX512_PF();
bool DL_API         hwAVX512_ER();
bool DL_API         hwAVX512_CD();
bool DL_API         hwAVX512_VL();
bool DL_API         hwAVX512_BW();
bool DL_API         hwAVX512_DQ();
bool DL_API         hwAVX512_IFMA();
bool DL_API         hwAVX512_VBMI();

} // hw
} // dl

#endif // DL_CORE_HW_H

